;-------------------------------------
Show_ADC_Values:
 lds	Temp, Voltage_LeftSlot+1
 rcall	DivHex
 sts	DebugBuffer+0, Di0 
 lds	Temp, Voltage_LeftSlot
 rcall	DivHex
 sts	DebugBuffer+1, Di1
 sts	DebugBuffer+2, Di0 
 
 lds	Temp, Voltage_LeftSlot_MAX+1
 rcall	DivHex
 sts	DebugBuffer+4, Di0 
 lds	Temp, Voltage_LeftSlot_MAX
 rcall	DivHex
 sts	DebugBuffer+5, Di1
 sts	DebugBuffer+6, Di0 
 
 lds	Temp, Current_LeftSlot+1
 rcall	DivHex
 sts	DebugBuffer+21, Di0 
 lds	Temp, Current_LeftSlot
 rcall	DivHex
 sts	DebugBuffer+22, Di1
 sts	DebugBuffer+23, Di0  
 
 mov	Temp, LeftSlot_PWM
 rcall	DivHex
 sts	DebugBuffer+25, Di1
 sts	DebugBuffer+26, Di0  

 mov	Temp, LeftSlot_NegativeCT
 rcall	DivHex
 sts	DebugBuffer+42, Di1
 sts	DebugBuffer+43, Di0  

 

 lds	Temp, Voltage_RightSlot+1
 rcall	DivHex
 sts	DebugBuffer+14, Di0 
 lds	Temp, Voltage_RightSlot
 rcall	DivHex
 sts	DebugBuffer+15, Di1
 sts	DebugBuffer+16, Di0 

 lds	Temp, Voltage_RightSlot_MAX+1
 rcall	DivHex
 sts	DebugBuffer+18, Di0 
 lds	Temp, Voltage_RightSlot_MAX
 rcall	DivHex
 sts	DebugBuffer+19, Di1
 sts	DebugBuffer+20, Di0 
  
 lds	Temp, Current_RightSlot+1
 rcall	DivHex
 sts	DebugBuffer+35, Di0 
 lds	Temp, Current_RightSlot
 rcall	DivHex
 sts	DebugBuffer+36, Di1
 sts	DebugBuffer+37, Di0  
 
 mov	Temp, RightSlot_PWM
 rcall	DivHex
 sts	DebugBuffer+39, Di1
 sts	DebugBuffer+40, Di0  
 
 mov	Temp, RightSlot_NegativeCT
 rcall	DivHex
 sts	DebugBuffer+56, Di1
 sts	DebugBuffer+57, Di0  



 mov	Temp, Status_Timer
 rcall	DivHex
 sts	DebugBuffer+9, Di1
 sts	DebugBuffer+10, Di0  
  
 ret








;-------------------------------------
;Hauptprogramm-Aufruf
PUT_DISPLAY:
 sbis	Status0, _SnifferFlag
 ret

 cli
 cbi	Status0, _SnifferFlag 
 sei

 ldi	YH, high (DebugBuffer)
 ldi	YL,	low	(DebugBuffer)
 lds	TempH, Debug_CT
 add	YL, TempH
 adc	YH, Null
 inc	TempH
 cpi	TempH, 180
 brne	_PD1
 clr	TempH 

_PD1:
 sts	Debug_CT, TempH
    
 ld		Temp, Y
 ldi	Temp3, $02			;ASCII
 dec	TempH
 rcall	Sniffer
 ret




;------------------------------------
Sniffer:
 cli
 rcall	SnifferStart
 swap	Temp3
 push	TempH
 ldi	TempH, 4
 
_SN1:
 rol	Temp3
 brcs	_SN11
 rcall	SnifferLow
 rjmp	_SN12

_SN11:
 rcall	SnifferHigh

_SN12:
 dec	TempH
 brne	_SN1

 ldi	Temp3, 8
 pop	TempH

_SN2:
 rol	TempH
 brcs	_SN21
 rcall	SnifferLow
 rjmp	_SN22

_SN21:
 rcall	SnifferHigh
 
_SN22:
 dec	Temp3
 brne	_SN2
 
_SN3:
 ldi	Temp3, 8

_SN31:
 rol	Temp
 brcs	_SN32
 rcall	SnifferLow
 rjmp	_SN33

_SN32:
 rcall	SnifferHigh
 
_SN33:
 dec	Temp3
 brne	_SN31
 sei
 ret


;----------------------------
SnifferStart:
 rcall	SnifferToggle
 rcall	SnifferToggle
 rcall	SnifferToggle
 andi	Temp3, 0b00001111
 ret

SnifferHigh:
 rcall	SnifferToggle
 rcall	SnifferToggle
 ret

SnifferLow:
 rcall	SnifferToggle
 ret

SnifferToggle:
 sbi	DebugPin, SnifPin		;use pin register to toggle portpin
 ret



;--------------------------------------------------------------------------------------------------
;Wandelt Byte in 2-stellige Hex-Zahl, Vorgabe: Temp
;wird fr Darstellung auf LCD bentigt
DivHex:
   
DivH_H:					
 mov 	TempH, Temp
 andi	TempH, $F0
 swap	TempH
 mov	Di1, TempH
 ldi	TempH, $30
 add	Di1, TempH
 ldi	TempH, $3A
 cp		Di1, TempH
 brcs	DivH_L
 ldi	TempH, 7
 add	Di1, TempH

DivH_L:					
 mov 	TempH, Temp
 andi	TempH, $0F
 mov	Di0, TempH
 ldi	TempH, $30
 add	Di0, TempH
 ldi	TempH, $3A
 cp		Di0, TempH
 brcs	DivH_E
 ldi	TempH, 7
 add	Di0, TempH

DivH_E:					
 ret










;--------------------------------------------------------------------------------------------------
;Teilt 8_Bit Wert in 3-stellige Dezimalzahl

DivDez:
 clr	Di0				; Alle temporren Dezimalstellen lschen
 clr	Di1
 clr	Di2
 
Div1:					    
 cpi	Temp, 100	
 brlo	Div2
 subi	Temp, 100
 inc	Di2
 rjmp	Div1

Div2:				
 cpi 	Temp, 10
 brlo 	DivE
 subi	Temp, 10
 inc	Di1
 rjmp	Div2

DivE:				
 mov	Di0, Temp
 ret

;--------------------------------------------------------
DivDezASC:
 clr	Di0				
 clr	Di1
 clr	Di2
 
DivDA1:					    
 cpi	Temp, 100	
 brlo	DivDA2
 subi	Temp, 100
 inc	Di2
 rjmp	DivDA1

DivDA2:				
 cpi 	Temp, 10
 brlo 	DivDAE
 subi	Temp, 10
 inc	Di1
 rjmp	DivDA2

DivDAE:				
 mov	Di0, Temp
 ldi	Temp, 48
 add	Di2, Temp
 add	Di1, Temp
 add	Di0, Temp
  
 ret


;--------------------------------------------------------------------------------------------------
;Teilt 16_Bit Wert in 4-stellige Dezimalzahl, TempH und Temp als Vorgabe

DivHL:
 clr	Di0				; Alle temporren Dezimalstellen lschen
 clr	Di1
 clr	Di2
 clr	Di3 


DivHL2:					    
 cpi	Temp, low(1000)		;Compare low byte
 ldi	Temp3, high(1000)	;
 cpc	TempH, Temp3	    ;Compare high byte
 brlo	DivHL3
 subi	Temp, low(1000)		;Subtract low bytes
 sbci	TempH, high(1000)	;Subtract high byte with carry
 inc	Di3
 rjmp	DivHL2

DivHL3:					    
 cpi	Temp, low(100)		;Compare low byte
 ldi	Temp3, high(100)	;
 cpc	TempH, Temp3	    ;Compare high byte
 brlo	DivHL4
 subi	Temp, low(100)		;Subtract low bytes
 sbci	TempH, high(100)	;Subtract high byte with carry
 inc	Di2
 rjmp	DivHL3

DivHL4:				
 cpi 	Temp, 10
 brlo 	DivHLEnd
 subi	Temp, 10
 inc	Di1
 rjmp	DivHL4

DivHLEnd:				
 mov	Di0, Temp

 ldi	Temp, 48		;ASCII-Zeichenumwandlung
 add	Di3, Temp
 add	Di2, Temp
 add	Di1, Temp
 add	Di0, Temp

 ret




 //End of file//