
.cseg
;Interruptvektoren 
.org    $0000	
 rjmp RESET						; RESET
 rjmp RESET						; External Interrupt0 
 rjmp RESET						; PinChange Interrupt0
 rjmp RESET						; PinChange Interrupt1
 rjmp RESET						; Wachdog TimeOut
 rjmp RESET						; Timer1 Capture
 rjmp LED_OUT_ISR						; Timer1 CompareA
 rjmp RESET						; Timer1 CompareB
 rjmp RESET						; Timer1 Overflow
 rjmp RESET					; Timer0 CompareA
 rjmp RESET						; Timer0 CompareB
 rjmp RESET						; Timer0 Overflow
 rjmp RESET						; Analog Comparator
 rjmp RESET						; ADC Conversion Complete
 rjmp RESET						; EEPROM Ready
 rjmp RESET						; USI Start  
 rjmp RESET						; USI Overflow  

 
RESET:
 cli							;Interrupts global ausschalten
 
;Stackpointer is initialised by hardware

;setup Ports
;Charger2   LED_Cathode_blue   LED_Cathode_red   LED_Cathode_green   Current_Slot2   Voltage_Slot2   Current_Slot1   Voltage_Slot1
 ldi	Temp, 0b11110000
 out	DDRA, Temp
 ldi	Temp, 0b01110000
 out	PortA, Temp
 
;---  ---  ---  ---  /RESET  Charger1  LED_Anode_2  LED_Anode1
 ldi	Temp, 0b00000111
 out	DDRB, Temp
 ldi	Temp, 0b00000010
 out	PortB, Temp

 ldi	Temp, 0b00001111
 sts	DIDR0, Temp

 clr	Null

;clear SRAM
 clr	XH
 ldi	XL, $60
 clr	TempH				;T44A: 256 Byte SRAM

_CLSR:
 st		X+, Null
 dec	TempH
 brne	_CLSR



;setup A/D-Converter
 ldi	Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADIF)|(0<<ADIE)|(1<<ADPS2)|(1<<ADPS0)			;ADC enabled, start conversion, Prescaler 32 -> 250kHz
 out	ADCSRA, Temp
 ldi	Temp, (0<<REFS1)															;VCC as reference, AD0 first input, single ended
 out	ADMUX, Temp

Wait1stConversion:
 sbic	ADCSRA, ADSC
 rjmp	Wait1stConversion
 

 ldi	Temp, (1<<ACD)				;disable Analog comparator to save power
 out	ACSR, Temp
 
 ldi	Temp, (1<<ADEN)|(0<<ADSC)|(1<<ADIF)|(0<<ADIE)|(1<<ADPS2)|(1<<ADPS0)			;clear interrupt flag
 out	ADCSRA, Temp 


;setup Timer0, Charger PWM
 ldi	Temp, (1<<COM0A1)|(1<<COM0A0)|(1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00)		;Fast_PWM
 out	TCCR0A, Temp
 ldi	Temp, (0<<CS01)|(1<<CS00)								;Prescaler 1 -> 8Mhz
 out	TCCR0B, Temp
 ldi	Temp, 255												;right Slot
 out	OCR0A, Temp
 ldi	Temp, 255												;left Slot	
 out	OCR0B, Temp


;setup Timer1, LED output timer
 ldi	Temp, (0<<WGM11)|(0<<WGM10)						 
 out	TCCR1A, Temp
 ldi	Temp, (0<<WGM13)|(1<<WGM12)|(1<<CS11)|(0<<CS10)			;CTC-Mode, OCR0A is top, Prescaler 1
 out	TCCR1B, Temp
 
 ldi	Temp, 250												;CTC top value, -> 4.00kHz
 out	OCR1AH, Null
 out	OCR1AL, Temp
 
 ldi	Temp, (1<<OCIE1A)										;enable compare Interrupt
 out	TIMSK1, Temp


 ldi	LeftSlot_PWM, 254
 ldi	RightSlot_PWM, 254
 ldi	Status_Timer, 30										;5min Battery Measure Interval
 clr	Timer_PSC
 clr	LeftSlot_NegativeCT
 clr	RightSlot_NegativeCT
 
 ldi	Temp, 0xFF
 ldi	TempH, 0x03
 sts	Voltage_LeftSlot_Old, Temp
 sts	Voltage_LeftSlot_Old+1, TempH
 sts	Voltage_RightSlot_Old, Temp
 sts	Voltage_RightSlot_Old+1, TempH
 sts	Voltage_LeftSlot, Temp
 sts	Voltage_LeftSlot+1, TempH
 sts	Voltage_RightSlot, Temp
 sts	Voltage_RightSlot+1, TempH

 clr	LEDs


 sei								;global interrupt enable

//End of file//
